<?php

class PluginBlogtags_HookBlogTags extends Hook {

	/*
	* Регистрация событий на хуки
	*/
	public function RegisterHook() {
		$this->AddHook('blog_add_before', 'BlogAddBefore', __CLASS__, -5);
		$this->AddHook('blog_add_after', 'BlogAdd', __CLASS__, -5);
		$this->AddHook('blog_edit_show', 'BlogEditShow', __CLASS__, -5);
		$this->AddHook('blog_add_show', 'BlogAddShow', __CLASS__, -5);
		$this->AddHook('blog_edit_after', 'BlogAdd', __CLASS__, -5);
		$this->AddHook('blog_edit_before', 'BlogAddBefore', __CLASS__, -5);

		$this->AddHook('template_form_add_blog_end', 'tplAddBlogEnd', __CLASS__, -5);
	}

	public function BlogAddBefore($aVars) {
		if ($oUserCurrent = $this->User_GetUserCurrent() and !$oUserCurrent->isAdministrator())
			$_REQUEST['blog_tags'] = implode(",", $_REQUEST['blog_tags_array']);
		$aVars["oBlog"]->setTags($_REQUEST['blog_tags']);
	}

	public function BlogAdd($aVars) {
		$this->PluginBlogtags_Blog_DeleteBlogTagsByBlogId($aVars["oBlog"]->getId());
		if ($aVars["oBlog"]->getTags()) {
			$aTags = explode(',', $aVars["oBlog"]->getTags());
			foreach ($aTags as $sTag) {
				$oTag = Engine::GetEntity('PluginBlogtags_ModuleBlog_EntityBlogTag');
				$oTag->setBlogId($aVars["oBlog"]->getId());
				$oTag->setUserId($aVars["oBlog"]->getOwnerId());
				$oTag->setText($sTag);
				$this->PluginBlogtags_Blog_AddBlogTag($oTag);
			}
		}
	}

	public function tplAddBlogEnd($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__) . 'inj.blog_add.tpl');
	}

	public function BlogEditShow($aVars) {
		if (!isset($_REQUEST['submit_blog_add'])) {
			$_REQUEST['blog_tags'] = $aVars["oBlog"]->getTags();
			$aBlogTags = explode(',', $aVars["oBlog"]->getTags());
			$this->Viewer_Assign('aBlogTags', $aBlogTags);
			$this->Viewer_Assign('aTags', $this->Blog_GetOpenBlogTags(20));
		}
	}

	public function BlogAddShow($aVars) {
		$this->Viewer_Assign('aBlogTags', array());
		$this->Viewer_Assign('aTags', $this->Blog_GetOpenBlogTags(20));
	}
}
?>
