<?php

class PluginBlogtags_ModuleBlog extends PluginBlogtags_Inherit_ModuleBlog {


	public function AddBlogTag(PluginBlogtags_ModuleBlog_EntityBlogTag $oBlogTag) {
		return $this->oMapperBlog->AddBlogTag($oBlogTag);
	}

	public function DeleteBlogTagsByBlogId($sBlogId) {
		if (is_null($sBlogId))
			return false;
		return $this->oMapperBlog->DeleteBlogTagsByBlogId($sBlogId);
	}

	public function GetOpenBlogTags($iLimit,$iUserId=null) {
		if (false === ($data = $this->Cache_Get("blog_tag_{$iLimit}_{$iUserId}_open"))) {
			$data = $this->oMapperBlog->GetOpenBlogTags($iLimit,$iUserId);
			$this->Cache_Set($data, "blog_tag_{$iLimit}_{$iUserId}_open", array('blog_update','blog_new'), 60*60*24*3);
		}
		return $data;
	}

	public function GetBlogsByTag($sTag,$iPage,$iPerPage,$bAddAccessible=true) {
		$aCloseBlogs = ($this->oUserCurrent && $bAddAccessible)
			? $this->GetInaccessibleBlogsByUser($this->oUserCurrent)
			: $this->GetInaccessibleBlogsByUser();

		$s = serialize($aCloseBlogs);
		if (false === ($data = $this->Cache_Get("blog_tag_{$sTag}_{$iPage}_{$iPerPage}_{$s}"))) {
			$data = array('collection'=>$this->oMapperBlog->GetBlogsByTag($sTag,$aCloseBlogs,$iCount,$iPage,$iPerPage),'count'=>$iCount);
			$this->Cache_Set($data, "blog_tag_{$sTag}_{$iPage}_{$iPerPage}_{$s}", array('blog_update','blog_new'), 60*60*24*2);
		}
		$data['collection']=$this->GetBlogsAdditionalData($data['collection']);
		return $data;
	}


	public function GetBlogTagsByLike($sTag,$iLimit) {
		if (false === ($data = $this->Cache_Get("blog_tag_like_{$sTag}_{$iLimit}"))) {
			$data = $this->oMapperBlog->GetBlogTagsByLike($sTag,$iLimit);
			$this->Cache_Set($data, "blog_tag_like_{$sTag}_{$iLimit}", array("blog_update","blog_new"), 60*60*24*3);
		}
		return $data;
	}
}
?>