<?php

class PluginBlogtags_ModuleBlog_EntityBlogTag extends Entity {
	/**
	 * Возвращает ID тега
	 *
	 * @return int|null
	 */
	public function getId() {
		return $this->_getDataOne('blog_tag_id');
	}
	/**
	 * Возвращает ID пользователя
	 *
	 * @return int|null
	 */
	public function getUserId() {
		return $this->_getDataOne('user_id');
	}
	/**
	 * Возвращает ID блога
	 *
	 * @return int|null
	 */
	public function getBlogId() {
		return $this->_getDataOne('blog_id');
	}
	/**
	 * Возвращает текст тега
	 *
	 * @return string|null
	 */
	public function getText() {
		return $this->_getDataOne('blog_tag_text');
	}

	/**
	 * Возвращает количество тегов
	 *
	 * @return int|null
	 */
	public function getCount() {
		return $this->_getDataOne('count');
	}
	/**
	 * Возвращает просчитанный размер тега для облака тегов
	 *
	 * @return int|null
	 */
	public function getSize() {
		return $this->_getDataOne('size');
	}


	/**
	 * Устанавливает ID тега
	 *
	 * @param int $data
	 */
	public function setId($data) {
		$this->_aData['blog_tag_id']=$data;
	}

	/**
	 * Устанавливает ID пользователя
	 *
	 * @param int $data
	 */
	public function setUserId($data) {
		$this->_aData['user_id']=$data;
	}
	/**
	 * Устанавливает ID блога
	 *
	 * @param int $data
	 */
	public function setBlogId($data) {
		$this->_aData['blog_id']=$data;
	}
	/**
	 * Устанавливает текст тега
	 *
	 * @param string $data
	 */
	public function setText($data) {
		$this->_aData['blog_tag_text']=$data;
	}
	/**
	 * Устанавливает просчитанный размер тега для облака тегов
	 *
	 * @param int $data
	 */
	public function setSize($data) {
		$this->_aData['size']=$data;
	}
}
?>