<?php

class PluginBlogtags_ModuleBlog_MapperBlog extends PluginBlogtags_Inherit_ModuleBlog_MapperBlog {
	public function AddBlogTag(PluginBlogtags_ModuleBlog_EntityBlogTag $oTopicTag) {
		$sql = "INSERT INTO ".Config::Get('db.table.blog_tag')."
			(
			user_id,
			blog_id,
			blog_tag_text
			)
			VALUES( ?d,  ?d,	?)
		";
		if ($iId=$this->oDb->query($sql,$oTopicTag->getUserId(),$oTopicTag->getBlogId(),$oTopicTag->getText()))
		{
			return $iId;
		}
		return false;
	}


	public function DeleteBlogTagsByBlogId($sBlogId) {
		$sql = "DELETE FROM ".Config::Get('db.table.blog_tag')."
			WHERE
				blog_id = ?d
		";
		if ($this->oDb->query($sql,$sBlogId)) {
			return true;
		}
		return false;
	}


	public function AddBlog(ModuleBlog_EntityBlog $oBlog) {
		$sql = "INSERT INTO ".Config::Get('db.table.blog')."
			(user_owner_id,
			blog_title,
			blog_description,
			blog_type,
			blog_date_add,
			blog_limit_rating_topic,
			blog_url,
			blog_avatar,
			blog_tags
			)
			VALUES(?d,  ?,	?,	?,	?,	?, ?, ?, ?)
		";
		if ($iId=$this->oDb->query($sql,$oBlog->getOwnerId(),$oBlog->getTitle(),$oBlog->getDescription(),$oBlog->getType(),$oBlog->getDateAdd(),$oBlog->getLimitRatingTopic(),$oBlog->getUrl(),$oBlog->getAvatar(),$oBlog->getTags())) {
			return $iId;
		}
		return false;
	}

	public function UpdateBlog(ModuleBlog_EntityBlog $oBlog) {
		$sql = "UPDATE ".Config::Get('db.table.blog')."
			SET
				blog_title= ?,
				blog_description= ?,
				blog_type= ?,
				blog_date_edit= ?,
				blog_rating= ?f,
				blog_count_vote = ?d,
				blog_count_user= ?d,
				blog_count_topic= ?d,
				blog_limit_rating_topic= ?f ,
				blog_url= ?,
				blog_avatar= ?,
				blog_tags = ?
			WHERE
				blog_id = ?d
		";
		if ($this->oDb->query($sql,$oBlog->getTitle(),$oBlog->getDescription(),$oBlog->getType(),$oBlog->getDateEdit(),$oBlog->getRating(),$oBlog->getCountVote(),$oBlog->getCountUser(),$oBlog->getCountTopic(),$oBlog->getLimitRatingTopic(),$oBlog->getUrl(),$oBlog->getAvatar(),$oBlog->getTags(),$oBlog->getId())) {
			return true;
		}
		return false;
	}


	public function GetOpenBlogTags($iLimit,$iUserId=null) {
		$sql = "
			SELECT
				tt.blog_tag_text,
				count(tt.blog_tag_text)	as count
			FROM
				".Config::Get('db.table.blog_tag')." as tt,
				".Config::Get('db.table.blog')." as b
			WHERE
				1 = 1
				{ AND tt.user_id = ?d }
				AND
				tt.blog_id = b.blog_id
				{ AND b.blog_type <> ?}
			GROUP BY
				tt.blog_tag_text
			ORDER BY
				count desc
			LIMIT 0, ?d
				";
		$aReturn=array();
		$aReturnSort=array();
		if ($aRows=$this->oDb->select($sql,is_null($iUserId) ? DBSIMPLE_SKIP : $iUserId,is_null($iUserId) ? 'close' : DBSIMPLE_SKIP ,$iLimit)) {
			foreach ($aRows as $aRow) {
				$aReturn[mb_strtolower($aRow['blog_tag_text'],'UTF-8')]=$aRow;
			}
			ksort($aReturn);
			foreach ($aReturn as $aRow) {
				$aReturnSort[]=Engine::GetEntity('PluginBlogtags_ModuleBlog_EntityBlogTag',$aRow);
			}
		}
		return $aReturnSort;
	}

	public function GetBlogsByTag($sTag,$aExcludeBlog,&$iCount,$iCurrPage,$iPerPage) {
		$sql = "
							SELECT
								blog_id
							FROM
								".Config::Get('db.table.blog_tag')."
							WHERE
								blog_tag_text = ?
								{ AND blog_id NOT IN (?a) }
                            ORDER BY blog_id DESC
                            LIMIT ?d, ?d ";

		$aBlogs=array();
		if ($aRows=$this->oDb->selectPage(
			$iCount,$sql,$sTag,
			(is_array($aExcludeBlog)&&count($aExcludeBlog)) ? $aExcludeBlog : DBSIMPLE_SKIP,
			($iCurrPage-1)*$iPerPage, $iPerPage
		)
		) {
			foreach ($aRows as $aBlog) {
				$aBlogs[]=$aBlog['blog_id'];
			}
		}
		return $aBlogs;
	}

	public function GetBlogTagsByLike($sTag,$iLimit) {
		$sTag=mb_strtolower($sTag,"UTF-8");
		$sql = "SELECT
				blog_tag_text
			FROM
				".Config::Get('db.table.blog_tag')."
			WHERE
				blog_tag_text LIKE ?
			GROUP BY
				blog_tag_text
			LIMIT 0, ?d
				";
		$aReturn=array();
		if ($aRows=$this->oDb->select($sql,$sTag.'%',$iLimit)) {
			foreach ($aRows as $aRow) {
				$aReturn[]=Engine::GetEntity('PluginBlogtags_ModuleBlog_EntityBlogTag',$aRow);
			}
		}
		return $aReturn;
	}

}
?>